From bfb32d9211684fb76e018833a88f3013bd80ea2a Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 16:32:36 +0000
Subject: [PATCH 31/51] check the API


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 0774ae5..eceb9a5 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -474,3 +474,52 @@ class ModuleMDLinter(object):
         particular profile is selected."""
         if 'profiles' in self.mmd:
             self.check_is_dict(*self.mmd['profiles'].values())
+
+    @warning
+    @guidelines_link('#Module_API')
+    def lint_api_exists(self):
+        """Every module SHOULD define its public API."""
+        self.check('api' in self.mmd)
+
+    @error
+    @guidelines_link('#Module_API')
+    @detail("The 'api' block must be a dictionary (key/value).")
+    @prerequisite('api_exists')
+    def lint_api_dict(self):
+        """Every module SHOULD define its public API."""
+        self.check_is_dict(self.mmd['api'])
+
+    @warning
+    @guidelines_link('#Module_API')
+    @detail("The 'api' block should only have the 'rpms' key.")
+    @prerequisite('api_dict')
+    def lint_api_keys(self):
+        """Every module SHOULD define its public API. Currently the only
+        supported type of API are binary RPM packages."""
+        self.check(set(self.mmd['api']) == {'rpms'})
+
+    @error
+    @guidelines_link('#Module_API')
+    @detail("All 'api' blocks must be lists.")
+    @prerequisite('api_dict')
+    def lint_api_blocks_are_lists(self):
+        """Every module SHOULD define its public API."""
+        self.check_is_list(*self.mmd['api'].values())
+
+    @warning
+    @guidelines_link('#Module_API')
+    @detail("The list of API RPM packages is empty.")
+    @prerequisite('api_blocks_are_lists')
+    def lint_api_rpms_empty(self):
+        """Every module SHOULD define its public API."""
+        if 'rpms' in self.mmd['api']:
+            self.check(len(self.mmd['api']['rpms']) > 0)
+
+    @error
+    @guidelines_link('#Module_API')
+    @detail("Every 'api' block must be a list of scalar items.")
+    @prerequisite('api_blocks_are_lists')
+    def lint_api_blocks_items_are_scalar(self):
+        """Every module SHOULD define its public API."""
+        for block in self.mmd['api'].values():
+            self.check_is_scalar(*block)

